<?php

// phpMyDoc - MySQL Documenter
// Copyright (C) 2001-2002  Justin Streufert
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// Documentation

include('main.inc');

if(!isset($mode)) $mode = 'view';

if($mode == 'editsubmit') {
   prepare_description($table);
   db_q("update PMD_descriptions set descr=\"$tabledesc\" where tbl=\"$table\" and col is NULL");

   $dbq = db_q("desc $table");
   $dbc = dbcount($dbq);
   for($x=0; $x!=$dbc; $x++) {
      $dbr = dbrow($dbq, $x, TRUE);
      $varname = 'col_' . $dbr['Field'];
      prepare_description($table, $dbr['Field']);
      db_q("update PMD_descriptions set descr=\"" . $$varname . "\" where tbl=\"$table\" and col=\"" . $dbr['Field'] . "\"");
   }  
     
   $mode = 'view';
}

$html = '<HTML><HEAD><TITLE>$table</TITLE><BODY BGCOLOR="#FFFFFF">';
if($mode == 'edit') {
   $html .= '<FORM METHOD=POST ACTION="doc.php">';
   $html .= "<INPUT TYPE=HIDDEN NAME=table VALUE=$table>";
   $html .= "<INPUT TYPE=HIDDEN NAME=mode VALUE=editsubmit>";
   $html .= '<CENTER><INPUT TYPE=SUBMIT NAME=submit VALUE="' . pmd_lm('submit-changes') . '"></CENTER>';
}
$html .= '<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH="100%">';
$html .= '<TR VALIGN=BOTTOM><TD WIDTH="100%">';
$html .= f('l') . '<B>' . $table . '</B></FONT><BR>' . f();
$tbld = db_qval("select descr from PMD_descriptions where tbl='$table' and
		  col is NULL");

if($mode == 'edit') {
   $html .= "<TEXTAREA NAME=tabledesc WRAP=PHYSICAL COLS=35 ROWS=3>$tbld</TEXTAREA>";
} else {
   if(strlen($tbld)) $html .= $tbld; else $html .= pmd_lm('no-table-desc');
}

$html .= '</FONT></TD><TD ALIGN=RIGHT>' . f();

switch($mode) {
 case 'view':
   $html .= "<B>" . str_replace(' ', '&nbsp;', pmd_lm('view-mode')) . "</B><BR>";
   $html .= "<A HREF=\"doc.php?table=$table&mode=edit\">";
   $html .= str_replace(' ', '&nbsp;', pmd_lm('switch-to-edit')) . "</A>";
   break;
   
 case 'edit':
   $html .= "<B>" . str_replace(' ', '&nbsp;', pmd_lm('edit-mode')) . "</B><BR>";
   $html .= "<A HREF=\"doc.php?table=$table&mode=view\">";
   $html .= str_replace(' ', '&nbsp;', pmd_lm('switch-to-view')) . "</A>";
   break;
}

$html .= '</FONT></TD></TR></TABLE>';
$html .= '<HR NOSHADE SIZE=1>';

// Now display columns
// 
$dbq = db_q("desc $table");
$dbc = dbcount($dbq);

$html .= '<TABLE CELLPADDING=2 CELLSPACING=2 BORDER=0 WIDTH="100%">';

for($x=0; $x!=$dbc; $x++) {
   $dbr = dbrow($dbq, $x, TRUE);
   if(strlen($dbr['Key'])) {
      if($dbr['Key'] == 'PRI') $color = 'CCFFCC'; else $color = 'CCCCFF';
   } else {
      $color = 'EEEEEE';
   }
   $html .= '<TR VALIGN=TOP><TD BGCOLOR="#' . $color . '">';
   $html .= f() . '<B>' . $dbr['Field'] . '</B></FONT><BR>';
   
   $html .= f('s');
   $html .= '<B>' . $dbr['Type'] . '</B><BR><BR>';
   if($dbr['Null'] == 'YES') $html .= pmd_lm('null-yes'); else
     $html .= pmd_lm('null-no');
   if(strlen($dbr['Default'])) $html .= "<BR>" . pmd_lm('default') .
     ':&nbsp;' . $dbr['Default'];
   $html .= '</FONT></TD><TD WIDTH="100%">' . f();
   
   if(strlen($dbr['Key'])) {
      switch($dbr['Key']) {
       case 'PRI':
	 $html .= '<B>' . pmd_lm('primary-key') . '</B>';
	 break;
       
       case 'MUL':
	 $html .= pmd_lm('multiple-key');
	 break;
	 
       default:
	 trigger_error('unknown-key');
      }
      $html .= '<BR>';
   }
   
   $cdesc = db_qval("select descr from PMD_descriptions where tbl='$table'
		      and col='" . $dbr['Field'] . "'");

   if($mode == 'edit') {
      $html .= "<TEXTAREA NAME=col_" . $dbr['Field'] . " WRAP=PHYSICAL COLS=60 ROWS=3>$cdesc</TEXTAREA>";
   } else {
      if(strlen($cdesc)) $html .= linkify($cdesc, $table); else
	$html .= pmd_lm('no-col-desc');
   }


   $html .= '</FONT></TD></TR>';
   $html .= '<TR><TD COLSPAN=2><HR NOSHADE SIZE=1></TD></TR>';
}

$html .= '</TABLE>';
if($mode == 'edit') {
   $html .= '<CENTER><INPUT TYPE=SUBMIT NAME=submit VALUE="' . pmd_lm('submit-changes') . '"></CENTER>';
   $html .= '</FORM>';
}
$html .= '</BODY></HTML>';

echo $html;

?>
