<?php

// phpMyDoc - MySQL Documenter
// Copyright (C) 2001-2002  Justin Streufert
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

include('main.inc');  

if(isset($format)) {
   switch($format) {
    case 'html':
       export_html();
       break;
    case 'tables':
       export_table();
       break;
    case 'xml':
       export_xml();
       break;
    default:
      trigger_error(pmd_lm('unknown-export-format'), E_USER_ERROR);
   }
} else {
   $html = '<HTML><HEAD><TITLE>Export</TITLE></HEAD><BODY BGCOLOR="#FFFFFF">';
   $html .= f('l') . '<B>' . pmd_lm('export') . '</B></FONT>' . f() . '<P>';
   $html .= pmd_lm('export-explanation');
   $html .= '<UL>';
   $html .= '<LI><A HREF="export.php?format=html">' . pmd_lm('exp-big-html') . '</A>';
   $html .= '<LI><A HREF="export.php?format=tables">' . pmd_lm('exp-tables') . '</A>';
   $html .= '<LI><A HREF="export.php?format=xml">' . pmd_lm('exp-xml') . '</A>';
   $html .= '</UL></FONT></BODY></HTML>';
   echo $html;
}

function export_html()
{
      $html = '<HTML><HEAD><TITLE>' . kPMD_Title . '</TITLE><BODY BGCOLOR="#FFFFFF">';
      $html .= '<A NAME="top">';
      $html .= f('l') . '<B>' . kPMD_Title . '</B></FONT><BR>';
      $html .= f() . pmd_lm('schema-documentation') . '<BR><BR>' . date('F j, Y') . '<BR>';
      $html .= pmd_lm('generated-by') . '</FONT><P>';
      $tablesq = db_q('show tables');
      $tablesc = dbcount($tablesq);
      
      $html .= f() . '||ReplaceWithJumps||</FONT>';
      
      $jumps = '';
      for($t=0; $t!=$tablesc; $t++) {
	 list($table) = dbrow($tablesq, $t);
	 if($table != 'PMD_descriptions') {
	    if(strlen($jumps)) $jumps .= ' | ';
	    $jumps .= "<A HREF=\"#$table\">$table</A>";
	      
	    $html .= '<HR NOSHADE SIZE=4>';
	    $html .= "<A NAME=\"$table\">";
	    $html .= f('l') . '<B>' . $table . '</B></FONT><BR>' . f();
	    $tbld = db_qval("select descr from PMD_descriptions where 
			      tbl='$table' and col is NULL");
	    
	    if(strlen($tbld)) $html .= $tbld; else $html .=
	      pmd_lm('no-table-desc');
	    $html .= '</FONT>';
	    
	    // Now display columns
	    // 
	    $dbq = db_q("desc $table");
	    $dbc = dbcount($dbq);
	    
	    $html .= 
	      '<TABLE CELLPADDING=2 CELLSPACING=2 BORDER=0 WIDTH="100%">';
	    
	    for($x=0; $x!=$dbc; $x++) {
	       $dbr = dbrow($dbq, $x, TRUE);
	       if(strlen($dbr['Key'])) {
		  if($dbr['Key'] == 'PRI') $color = 'CCFFCC'; else 
		    $color = 'CCCCFF';
	       } else {
		  $color = 'EEEEEE';
	       }
	       $html .= '<TR VALIGN=TOP><TD BGCOLOR="#' . $color . '">';
	       $html .= f() . '<B>' . $dbr['Field'] . '</B></FONT><BR>';
	       
	       $html .= f('s');
	       $html .= '<B>' . $dbr['Type'] . '</B><BR><BR>';
	       if($dbr['Null'] == 'YES') $html .= pmd_lm('null-yes'); else
		 $html .= pmd_lm('null-no');
	       if(strlen($dbr['Default'])) $html .= '<BR>' . 
		 pmd_lm('default') . ':&nbsp;' . $dbr['Default'];
	       $html .= '</FONT></TD><TD WIDTH="100%">' . f();
	       
	       if(strlen($dbr['Key'])) {
		  switch($dbr['Key']) {
		   case 'PRI':
		     $html .= '<B>' . pmd_lm('primary-key') . '</B>';
		     break;
		     
		   case 'MUL':
		     $html .= pmd_lm('multiple-key');
		     break;
		     
		   default:
		     trigger_error(pmd_lm('unknown-key'));
		  }
		  $html .= '<BR>';
	       }
	       
	       $cdesc = db_qval("select descr from PMD_descriptions where tbl='$table'
				  and col='" . $dbr['Field'] . "'");
	       $html .= linkify($cdesc, $table, '#');
	       $html .= '</FONT></TD></TR>';
	       $html .= '<TR><TD COLSPAN=2><HR NOSHADE SIZE=1></TD></TR>';
	    }
	    $html .= '</TABLE>';
	    $html .= f() . '<CENTER><A HREF="#top">' . pmd_lm('back-to-top') .
	      '</A></CENTER></FONT>';
	 }
      }
      
      $html .= '</BODY></HTML>';

      $html = str_replace('||ReplaceWithJumps||', $jumps, $html);
      echo $html;
}

function export_table()
{
      $html = '<HTML><HEAD><TITLE>' . kPMD_Title . '</TITLE><BODY BGCOLOR="#FFFFFF">';
      $html .= '<A NAME="top">';
      $html .= f('l') . '<B>' . kPMD_Title . '</B></FONT><BR>';
      $html .= f() . pmd_lm('schema-documentation') . '<BR><BR>' . date('F j, Y') . '<BR>';
      $html .= pmd_lm('generated-by') . '</FONT><P>';
      $tablesq = db_q('show tables');
      $tablesc = dbcount($tablesq);
      
      $html .= f() . '||ReplaceWithJumps||</FONT><BR>';
      
      $jumps = '';
      for($t=0; $t!=$tablesc; $t++) {
	 list($table) = dbrow($tablesq, $t);
	 if($table != 'PMD_descriptions') {
	    if(strlen($jumps)) $jumps .= ' | ';
	    $jumps .= "<A HREF=\"#$table\">$table</A>";
	    
	    $html .= '<BR>';
      
	    $html .= '<TABLE CELLPADDING=3 CELLSPACING=0 COLOR="#000" BORDER=1 WIDTH="10%">';
	    
	    //table names 
	    $html .= "<TD><A NAME=\"$table\">";
	    $html .= f('l') . '<CENTER><B>' . $table . '</B></CENTER></FONT></A></TD>';
	    
	    //table description
	    $tbld = db_qval("select descr from PMD_descriptions where tbl='$table' and col is NULL");
	    if(strlen($tbld))
	    {
	      $html .='<TD><B> ' . f() . $tbld . '</FONT></B></TD>'; 
	    }
	    
	    // Now display columns
	    // 
	    $dbq = db_q("desc $table");
	    $dbc = dbcount($dbq);
	    
	    for($x=0; $x!=$dbc; $x++) {
	       $dbr = dbrow($dbq, $x, TRUE);
	       if(strlen($dbr['Key'])) {
		        if($dbr['Key'] == 'PRI') $color = 'CCFFCC'; else $color = 'CCCCFF';
	       } else {
		        $color = 'EEEEEE';
	       }
	       $html .= '<TR VALIGN=TOP><TD BGCOLOR="#' . $color . '">' . f();
	   
          if(strlen($dbr['Key'])) {    
            switch($dbr['Key']) {
              case 'PRI':
                $html .= '<B>' . $dbr['Field'] . ' </B>'; // primary key
                break;
              
              case 'MUL':
                $html .= '<B><I>' . $dbr['Field'] . ' <I></B>'; // multiple key
                break;
              
              default:
                trigger_error(pmd_lm('unknown-key'));
                
            } 
           } else {
              $html .=$dbr['Field']; // just column name
           }
           
	       $html .= '</FONT><BR></TD>';
	       
	       
	       $cdesc = db_qval("select descr from PMD_descriptions where tbl='$table' and col='" . $dbr['Field'] . "'");
	       
	       if (strlen($cdesc)) {
	       $html .= '<TD WIDTH="100%" nowrap>' . f();
	       $html .= linkify($cdesc, $table, '#');
	       
	       $html .= '</FONT></TD></TR>';
	       }
	       
	       $html .= '</TR>';
	    }
	    $html .= '</TABLE>';
	 }
      }
      $html .= f() . '<CENTER><A HREF="#top">' . pmd_lm('back-to-top') .
	      '</A></CENTER></FONT>';
      $html .= '</BODY></HTML>';

      $html = str_replace('||ReplaceWithJumps||', $jumps, $html);
      echo $html;
}

function export_xml_indent($n)
{
      $x = '';
      for($c=0; $c!=$n; $c++) {
         $x .= '  ';
      }
      return $x;
}

function export_xml()
{
      // take care of the xml header and file header data
      $xml = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";
      $xml .= "<phpMyDoc>\n";
      $xml .= export_xml_indent(1) . "<schema title=\"" . kPMD_Title . "\">\n";
      $xml .= export_xml_indent(2) . '<date_generated>' . date("F j, Y") . "</date_generated>\n";
      $xml .= export_xml_indent(2) . "<generated_by system=\"phpMyDoc\" version=\"" . kPMD_Version . "\" />\n";
      $xml .= export_xml_indent(1) . "</schema>\n";

      $tablesq = db_q('show tables');
      $tablesc = dbcount($tablesq);
      
      // loop thru the tables generating xml
      for($t=0; $t!=$tablesc; $t++) {
	 list($table) = dbrow($tablesq, $t);
	 if($table != 'PMD_descriptions') {
	    $xml .= export_xml_indent(1) . "<table name=\"" . $table . "\">\n";
	    $tbld = db_qval("select descr from PMD_descriptions where 
			      tbl='$table' and col is NULL");

	    // table description from phpMyDoc table
	    if(strlen($tbld)) $xml .= export_xml_indent(2) . '<description>' . htmlentities($tbld) . "</description>\n";
	    
	    // Now display columns
	    // 
	    $dbq = db_q("desc $table");
	    $dbc = dbcount($dbq);
	    	    
	    for($x=0; $x!=$dbc; $x++) {
	       $dbr = dbrow($dbq, $x, TRUE);
	       
            //name and type
	    $xml .=  export_xml_indent(2) . "<field>\n";
	    $xml .=  export_xml_indent(3) . '<attributes name="' . $dbr['Field'] . '" type="' . $dbr['Type'] . '"';

	   // keys
              if(strlen($dbr['Key']))	 {
		  switch($dbr['Key']) {
		   case 'PRI':
		     $xml .= ' primarykey="Y"';
		     break;
		     
		   case 'MUL':
		     $xml .= ' multiplekey="Y"';
		     break;
		     
		   default:
		     $xml .= ' unknownkey="Y"';
		  }

	       }
	       
	       // null or not
	       if($dbr['Null'] == 'YES') $xml .= ' notnull="N"';
               else  $xml .= ' notnull="Y"';
                
               // default
               if(strlen($dbr['Default'])) $xml .= ' default="' . addslashes($dbr['Default']) . '"';

		// close the attributes
	        $xml .= " />\n";
	              
               $cdesc = db_qval("select descr from PMD_descriptions where tbl='$table'
				  and col='" . $dbr['Field'] . "'");

	       $xml .=  export_xml_indent(3) . '<documentation>' . htmlentities($cdesc) . "</documentation>\n";
	       $xml .=  export_xml_indent(2) . "</field>\n";
	    }
	    
	    $xml .= export_xml_indent(1) . "</table>\n";
	}    
      }
	      

      $xml .= '</phpMyDoc>';

      header("Content-Type: text/xml");
      echo $xml;
}

?>
